import { Component, OnInit, OnDestroy } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { Subscription } from 'rxjs/Rx';
import { JhiEventManager  } from 'ng-jhipster';

import { Geocity } from './geocity.model';
import { GeocityService } from './geocity.service';

@Component({
    selector: 'jhi-geocity-detail',
    templateUrl: './geocity-detail.component.html'
})
export class GeocityDetailComponent implements OnInit, OnDestroy {

    geocity: Geocity;
    private subscription: Subscription;
    private eventSubscriber: Subscription;

    constructor(
        private eventManager: JhiEventManager,
        private geocityService: GeocityService,
        private route: ActivatedRoute
    ) {
    }

    ngOnInit() {
        this.subscription = this.route.params.subscribe((params) => {
            this.load(params['id']);
        });
        this.registerChangeInGeocities();
    }

    load(id) {
        this.geocityService.find(id).subscribe((geocity) => {
            this.geocity = geocity;
        });
    }
    previousState() {
        window.history.back();
    }

    ngOnDestroy() {
        this.subscription.unsubscribe();
        this.eventManager.destroy(this.eventSubscriber);
    }

    registerChangeInGeocities() {
        this.eventSubscriber = this.eventManager.subscribe(
            'geocityListModification',
            (response) => this.load(this.geocity.id)
        );
    }
}
